#include <iostream>
#include <fstream>

#include "hash.h"

#ifndef INPUT_H
#define INPUT_H

using namespace std;

int Input_ext_qual_pair(string extqualname_1, string extqualname_2, hash_map <string, Seq_pair, std_string_hash> & seq_pairs){
     
     ifstream infile_1(extqualname_1.c_str(), ifstream::in);
     
     if (!infile_1){
             
             cerr << "Open quality file error : " << extqualname_1 << endl;
             exit(0);
             
             }
     
     string buffer;
     
     if (_single_input){
                        
                        long count = 0;
                        
                        while (getline(infile_1, buffer)){
                              
                              if (buffer[0] != '>') {
                                            
                                            cerr << "Quality input error at sequence : " << count << endl;
                                            return 1;
                                            
                                            }
                              
                              string label = buffer.substr(0, buffer.size() - 2);     
                              string qual_1;
                              string qual_2;
                        
                              getline(infile_1, qual_1);
                              getline(infile_1, buffer);
                              getline(infile_1, qual_2);
                        
                              if (seq_pairs.count(label) == 0){
                                                   
                                                   cerr << "Waring : quality id " << label << " cannot be found in input sequences" << endl;
                                                   
                                                   }
                              else {
                             
                                   seq_pairs[label].Add_qual_1(qual_1);
                                   seq_pairs[label].Add_qual_2(qual_2);
                             
                                   }
                        
                               count ++;    
                        }                                 
           }
     else {
          
          ifstream infile_2(extqualname_2.c_str(), ifstream::in);
     
          if (!infile_2){
             
                         cerr << "Open quality file error : " << extqualname_2 << endl;
                         exit(0);
             
             }
          
          //qual_1
          
          long  count = 0;
          while (getline(infile_1, buffer)){
                
                if (buffer[0] != '>') {
                                            
                                            cerr << "Quality input error at sequence : " << count << endl;
                                            return 1;
                                            
                                            }
                
                string label = buffer.substr(0, buffer.size() - 2);     
                string qual_1;
                
                getline(infile_1, qual_1);
                
                if (seq_pairs.count(label) == 0)                                                   
                     cerr << "Waring : quality id" << label << "cannot be found in input sequences" << endl;
                                                   
                else 
                     seq_pairs[label].Add_qual_1(qual_1);
                
                count ++;
                }
                    
          //qual_2
          count = 0;
          while (getline(infile_2, buffer)){
                
                if (buffer[0] != '>') {
                                            
                                            cerr << "Quality input error at sequence : " << count << endl;
                                            return 1;
                                            
                                            }
                
                string label = buffer.substr(0, buffer.size() - 2);     
                string qual_2;
                
                getline(infile_2, qual_2);
                
                if (seq_pairs.count(label) == 0)                                                   
                     cerr << "Waring : quality id" << label << "cannot be found in input sequences" << endl;
                                                   
                else 
                     seq_pairs[label].Add_qual_2(qual_2);
                
                count ++;
                }
          
          infile_2.close();
          infile_2.clear();
          
          }
     
     infile_1.close();
     infile_1.clear();
     
     return 0;
     }


int Input_reads_pair(string infilename_1, string infilename_2, string extqualname_1, string extqualname_2, hash_map <string, Seq_pair, std_string_hash> & seq_pairs, vector <string> &order, bool _single_input){//Updated
    
    
    ifstream infile_1(infilename_1.c_str(), ifstream::in);
    
    if (!infile_1){
                 
                 cerr << "Open input file error : " << infilename_1 << endl;
                 exit(0);
                 
                 }
       
    string buffer;
    //long count = 0;
    
    if (_single_input){
                       
                       long count = 0;
                       
                       while (getline(infile_1, buffer)){
                              //Seqs_1
                              
                              if (((_in_format) && (buffer[0] != '@')) || ((!_in_format) && (buffer[0] != '>'))) {
                                                
                                                cerr << "Input error at sequence " << count << ", Please make sure input file is in FASTA or FASTQ format" << endl;
                                                return 1;
                                                }
                              
                              string label = buffer.substr(0, buffer.size() - 2);
                              string seq_1;
                              string qual_1;
                              
                              getline(infile_1, buffer);
                              seq_1 = buffer;
                              
                              if (_in_format){
                                              
                                              getline(infile_1, buffer);
                                              //string plus = buffer;
          
                                              getline(infile_1, buffer);
                                              qual_1 = buffer;
                                              
                                              }
                              
                              Seq Seq_1(seq_1, qual_1);
                                                                               
                              //Seqs_2
                              string seq_2;
                              string qual_2;
                              
                              getline(infile_1, buffer);
                              
                              if (((_in_format) && (buffer[0] != '@')) || ((!_in_format) && (buffer[0] != '>'))) {
                                                
                                                cerr << "Input error, Please make sure input file is in FASTA or FASTQ format" << endl;
                                                return 1;
                                                }
                              //string label_2 = buffer;
          
                              getline(infile_1, buffer);
                              seq_2 = buffer;
                             
                              if (_in_format){
                                              getline(infile_1, buffer);
                                              //string plus_2 = buffer;
          
                                              getline(infile_1, buffer);
                                              qual_2 = buffer;                                                                                                    
                                              }
                                              
                              Seq Seq_2(seq_2, qual_2);
          
                              //make seq_pair
                              
                              if (seq_pairs.count(label) == 0)
                                                         order.push_back(label);
                              
                              seq_pairs[label] = Seq_pair(Seq_1, Seq_2);                                                            
                              
                              count ++;
                                                         
                              }
                                                                                        
          }             
                              
          else {
                ifstream infile_2(infilename_2.c_str(), ifstream::in);
                if (!infile_2){
                 
                    cerr << "Open input file error : " << infilename_2 << endl;
                    exit(0);
                 
                    }
                                               
                //Seqs_1 
                
                long count = 0;
                   
                while (getline(infile_1, buffer)){
                              if (((_in_format) && (buffer[0] != '@')) || ((!_in_format) && (buffer[0] != '>'))) {
                                                
                                                cerr << "Input error, Please make sure input file is in FASTA or FASTQ format" << endl;
                                                return 1;
                                                }                              
                              
                              string label = buffer.substr(0, buffer.size() - 2);
          
                              getline(infile_1, buffer);
                              string seq = buffer;
                              
                              string qual;
                              
                              if (_in_format){
                                              getline(infile_1, buffer);
                                              //string plus = buffer;
          
                                              getline(infile_1, buffer);
                                              qual = buffer;
                                              }
                              
                              Seq Seq(seq, qual);
                              
                              if (seq_pairs.count(label) == 0)                              
                                                         order.push_back(label);
                              
                              seq_pairs[label].Add_seq_1(Seq);
                              
                              count ++;
                                                                                          
                              }                                                                                   
                //Seqs_2 
                count = 0;
                            
                while (getline(infile_2, buffer)){
                      
                              if (((_in_format) && (buffer[0] != '@')) || ((!_in_format) && (buffer[0] != '>'))) {
                                                
                                                cerr << "Input error, Please make sure input file is in FASTA or FASTQ format" << endl;
                                                return 1;
                                                }
                                                            
                              string label = buffer.substr(0, buffer.size() - 2);
          
                              getline(infile_2, buffer);
                              string seq = buffer;
                              
                              string qual;
                              
                              if (_in_format){
                                              getline(infile_2, buffer);
                                              //string plus = buffer;
          
                                              getline(infile_2, buffer);
                                              qual = buffer;
                                              }
                                              
                              Seq Seq(seq, qual);
                              
                              seq_pairs[label].Add_seq_2(Seq);
                              
                              count ++;
                              
                              }
               
               infile_2.close();
               infile_2.clear();
                              
               }
                                  
    infile_1.close();
    infile_1.clear();
    
    if (_ext_qual)
        return Input_ext_qual_pair(extqualname_1, extqualname_2, seq_pairs);
    
    return 0;
            
    }

int Input_ext_qual(string extqualname_1, hash_map <string, Seq_pair, std_string_hash> & seq_pairs){
     
     long count = 0;
     
     ifstream infile_1(extqualname_1.c_str(), ifstream::in);
     
     if (!infile_1){
             
             cerr << "Open quality file error : " << extqualname_1 << endl;
             exit(0);
             
             }
             
     string buffer;
     
     while (getline(infile_1, buffer)){
                
                if (buffer[0] != '>') {
                                            
                                            cerr << "Quality input error at sequence : " << count << endl;
                                            return 1;
                                            
                                            }
                
                string label = buffer;     
                string qual_1;
                
                getline(infile_1, qual_1);
                
                if (seq_pairs.count(label) == 0)                                                   
                     cerr << "Waring : quality id " << label << " cannot be found in input sequences" << endl;
                                                   
                else 
                     seq_pairs[label].Add_qual_1(qual_1);
                
                }
     
     infile_1.close();
     infile_1.clear();
     
     return 0;
     }

int Input_reads(string infilename_1, string extqualname_1, hash_map <string, Seq_pair, std_string_hash> & seq_pairs, vector <string> & order){ //Updated
    
    long count = 0;
    
    ifstream infile(infilename_1.c_str(), ifstream::in);
    
    if (!infile){
                 
                 cerr << "Open input file error : " << infilename_1 << endl;
                 exit(0);
                 
                 }
       
    string buffer;
    
    while (getline(infile, buffer)){
                              
                              if (((_in_format) && (buffer[0] != '@')) || ((!_in_format) && (buffer[0] != '>'))) {
                                                
                                                cerr << "Input error, Please make sure input file is in FASTA or FASTQ format" << endl;
                                                return 1;
                                                }
                              
                              count ++;
                              
                              string label = buffer;
                              
                              string seq_1;
                              string qual_1;
                              
                              getline(infile, buffer);
                              seq_1 = buffer;
                              
                              if (_in_format){
                                              getline(infile, buffer);
                                              //string plus = buffer;
          
                                              getline(infile, buffer);
                                              qual_1 = buffer;
                                              }
                                              
                              Seq Seq_1(seq_1, qual_1);
                              
                              if (seq_pairs.count(label) == 0)
                                                         order.push_back(label);    
                              
                              seq_pairs[label].Add_seq_1(Seq_1);                                                                                                                    
          
                              count ++;
          }
    
    infile.close();
    infile.clear();
    
    if (_ext_qual)
       return Input_ext_qual(extqualname_1, seq_pairs);
    
    return 0;
    }

#endif
